
* This program code is released under a Berkeley Systems Distribution 
  BSD-2-Clause license, an open-source license which permits free 
  reuse and republication under conditions;

/*
Copyright (c) 2014, Thomas E. Billings
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

%global sqlrc save_syntax save_syserr save_sqlrc;

%* macro variables to flag/retain error indicators;
%let sqlrc=0;
%let save_syntax=0;
%let save_syserr=0;
%let save_sqlrc=0;

****************************************************************************;
* macro to capture error conditions from system-set macro variables.        ;
* also check if in special syntax check scan mode                           ;
****************************************************************************;

%macro save_err_flags;
	%if ((%nrstr(OBS=0) = %nrquote(%sysfunc(getoption(obs,keyword)))) AND
		(NOREPLACE = %sysfunc(getoption(replace,keyword)))) %then %do;
		%let save_syntax=1;
	    %put save_err_flags: save_syntax=&save_syntax;
		%end;

	%if ((&SYSERR ne 0) and (&SYSERR ne 4)) %then %do;
		%let save_syserr=&SYSERR;
	    %put save_err_flags: save_syserr=&save_syserr;
        %end;

	%if ((&SQLRC ne 0) and (&SQLRC ne 4)) %then %do;
		%let save_sqlrc=&SQLRC;
	    %put save_err_flags: save_sqlrc=&save_sqlrc;
		%end;

	%* more elegant macro IN operator is available but works only if
	  system option selected.  The above code will always work;
%mend;

